/**
 * View page module
 *
 * @module     mod_interactivevideo/viewannotation
 * @copyright  2024 Sokunthearith Makara <sokunthearithmakara@gmail.com>
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
define("mod_interactivevideo/viewannotation",["jquery","core/event_dispatcher","core/toast","mod_interactivevideo/quickform","mod_interactivevideo/libraries/jquery-ui"],(function($,eventDispatcher,Toast,quickform){const{dispatchEvent:dispatchEvent}=eventDispatcher,ctRenderer={},bsAffix=$("body").hasClass("bs-5")?"-bs":"";let annotations,totaltime,activityType,contentTypes,displayoptions,releventAnnotations,completionid,player,lastrun,viewedAnno=[];const $videoNav=$("#video-nav"),$interactionNav=$("#interactions-nav"),$loader=$("#background-loading"),renderAnnotationItems=async(annos,start,totaltime)=>{releventAnnotations=annos,window.IVANNO=annos;let actualduration=totaltime;const skipsegments=annos.filter((x=>"skipsegment"==x.type));skipsegments.length>0&&skipsegments.forEach((x=>{const length=Number(x.title)-Number(x.timestamp);actualduration-=length}));const completableAnno=releventAnnotations.filter((x=>1==x.hascompletion)),actualAnnotationCounts=completableAnno.length,xp=completableAnno.map((x=>Number(x.xp))).reduce(((a,b)=>a+b),0),completedAnnos=completableAnno.filter((x=>x.completed)),xpEarned=completedAnnos.map((x=>Number(x.earned))).reduce(((a,b)=>a+b),0);if($(".metadata").empty(),actualAnnotationCounts>0&&$(".metadata").append('<span class="d-inline-block iv-mr-3">\n            <i class="bi bi-stopwatch iv-mr-2"></i>'.concat((seconds=>{const hours=Math.floor(seconds/3600),minutes=Math.floor(seconds%3600/60),remainingSeconds=seconds%60;let string="";return hours>0&&(string+=hours+"h "),minutes>0&&(string+=minutes+"m "),remainingSeconds>0&&(string+=remainingSeconds+"s"),string})(Math.ceil(actualduration)),'</span>\n            <span class="d-inline-block iv-mr-3">\n        <i class="bi bi-bullseye iv-mr-2"></i>').concat(completedAnnos.length," / ").concat(actualAnnotationCounts,'</span>\n        <span class="d-inline-block"><i class="bi bi-star iv-mr-2"></i>').concat(xpEarned," / ").concat(xp,"</span>")),$("#interactions-nav ul").empty(),$("#video-nav ul").empty(),1==displayoptions.preventseeking&&$videoNav.addClass("no-pointer-events"),1==displayoptions.hidemainvideocontrols||1==displayoptions.hideinteractions)return 1==displayoptions.hidemainvideocontrols&&$("#wrapper").addClass("no-videonav"),void dispatchEvent("annotationitemsrendered",{annotations:annos,completed:completedAnnos.length,total:actualAnnotationCounts,xp:xpEarned,totalxp:xp});for(const x of annos){const renderer=ctRenderer[x.type];await renderer.renderItemOnVideoNavigation(x)}dispatchEvent("annotationitemsrendered",{annotations:annos,completed:completedAnnos.length,total:actualAnnotationCounts,xp:xpEarned,totalxp:xp}),$(".annolistinchapter").empty();const chapteritems=releventAnnotations.filter((x=>"skipsegment"!=x.type&&1==x.hascompletion));chapteritems.sort(((a,b)=>a.timestamp-b.timestamp)),chapteritems.forEach((x=>{const advanced=JSON.parse(x.advanced);("1"==advanced.visiblebeforecompleted&&!x.completed||"1"==advanced.visibleaftercompleted&&x.completed)&&$('[data-region="chapterlists"] li').each((function(){const cstart=$(this).data("start"),cend=$(this).data("end");x.timestamp>=cstart&&x.timestamp<cend&&$(this).find(".annolistinchapter").append('<li class="border-bottom anno d-flex align-items-center justify-content-between\n                         px-3 py-2 '.concat(x.completed?"completed":"",'" data-id="').concat(x.id,'" data-timestamp="').concat(x.timestamp,'">\n                         <span class="text-nowrap">\n                         <i class="small bi ').concat(x.completed?"bi-check-circle-fill text-success":"bi-circle",' iv-mr-2"></i>\n                         <i class="').concat(JSON.parse(x.prop).icon,' iv-mr-2"></i></span>\n                         <span class="flex-grow-1 text-truncate">').concat(x.formattedtitle,'</span>\n                         <span class="text-nowrap">').concat(x.xp,'<i class="bi bi-star iv-ml-1"></i></span></li>'))}))})),dispatchEvent("chapterrendered",{annotations:releventAnnotations})};return{renderAnnotationItems:renderAnnotationItems,init:function(url,cmid,interaction,course,userid){let start=arguments.length>5&&void 0!==arguments[5]?arguments[5]:0,end=arguments.length>6?arguments[6]:void 0,completionpercentage=arguments.length>7?arguments[7]:void 0,gradeiteminstance=arguments.length>8?arguments[8]:void 0,grademax=arguments.length>9?arguments[9]:void 0,vtype=arguments.length>10?arguments[10]:void 0,preventskip=!(arguments.length>11&&void 0!==arguments[11])||arguments[11],moment=arguments.length>12&&void 0!==arguments[12]?arguments[12]:null,doptions=arguments.length>13&&void 0!==arguments[13]?arguments[13]:{},token=arguments.length>14&&void 0!==arguments[14]?arguments[14]:null,extendedcompletion=arguments.length>15&&void 0!==arguments[15]?arguments[15]:null,isPreviewMode=arguments.length>16&&void 0!==arguments[16]&&arguments[16],isCompleted=arguments.length>17&&void 0!==arguments[17]&&arguments[17];quickform({contextid:M.cfg.contextid,courseid:course,cmid:cmid,interaction:interaction}),require(["theme_boost/bootstrap/modal"]),require(["theme_boost/bootstrap/tooltip"]),start=Number(start),isNaN(start)&&(start=0),end=Number(end),isNaN(end)&&(end=null),displayoptions=doptions;let playerReady=!1,uprogress=null,timeended=null;"true"==localStorage.getItem("limitedwidth")&&0==displayoptions.hidemainvideocontrols&&($("body").addClass("limited-width"),$("#controller #expand i").removeClass("bi-file").addClass("bi-square")),"spotify"==vtype&&$("body").addClass("limited-width");const convertSecondsToHMS=seconds=>{if(seconds<0)return"00:00";const h=Math.floor(seconds/3600),m=Math.floor(seconds%3600/60),s=Math.floor(seconds%3600%60);return(h>0?h+":":"")+(m<10?"0":"")+m+":"+(s<10?"0":"")+s},replaceProgressBars=percentage=>new Promise((resolve=>{let time=(percentage=percentage>100?100:percentage)/100*totaltime;$("#currenttime").text(convertSecondsToHMS(time)),$("#remainingtime").text(convertSecondsToHMS(totaltime-time)),$videoNav.find("#progress").css("width",percentage+"%"),$videoNav.find("#seekhead").css("left",percentage+"%"),resolve(!0)})),getAnnotations=()=>{const annnoitems=$.ajax({url:M.cfg.wwwroot+"/mod/interactivevideo/ajax.php",method:"POST",dataType:"text",data:{action:"get_items",sesskey:M.cfg.sesskey,id:interaction,contextid:M.cfg.courseContextId,token:token,cmid:cmid}}),userprogress=$.ajax({url:M.cfg.wwwroot+"/mod/interactivevideo/ajax.php",method:"POST",dataType:"text",data:{action:"get_progress",sesskey:M.cfg.sesskey,id:interaction,uid:userid,token:token,cmid:cmid,contextid:M.cfg.contextid,previewmode:isPreviewMode?1:0}}),getContentTypes=$.ajax({url:M.cfg.wwwroot+"/mod/interactivevideo/ajax.php",method:"POST",dataType:"text",data:{action:"get_all_contenttypes",sesskey:M.cfg.sesskey,token:token,cmid:cmid,contextid:M.cfg.contextid}});$.when(annnoitems,userprogress,getContentTypes).done((async function(annos,progress,ct){annotations=JSON.parse(annos[0]),player.live&&(annotations=[]),progress=JSON.parse(progress[0]),uprogress=progress,timeended=progress.timeended,contentTypes=JSON.parse(ct[0]),completionid=progress.id;let completiondetails=JSON.parse(progress.completiondetails||"[]");return"object"==typeof completiondetails&&(completiondetails=Object.values(completiondetails)),annotations=function(annotations,contentTypes,start,end){return annotations.filter((annotation=>!!contentTypes.some((y=>y.name===annotation.type))&&("skipsegment"===annotation.type?!(annotation.timestamp>end||annotation.title<start):annotation.timestamp>=start&&annotation.timestamp<=end||annotation.timestamp<0)))}(annotations,contentTypes,start,end),annotations=function(annotations,contentTypes,progress,start,end,completiondetails){const completedItems=""==progress.completeditems?[]:JSON.parse(progress.completeditems),contentTypeMap=new Map(contentTypes.map((ct=>[ct.name,ct])));return annotations.map((annotation=>{annotation.timestamp=Number(annotation.timestamp),annotation.xp=Number(annotation.xp);const completionitem=completiondetails.find((x=>JSON.parse(x).id==annotation.id));let advanced;annotation.earned=completionitem?Number(JSON.parse(completionitem).xp):0,"skipsegment"==annotation.type&&(annotation.title=Number(annotation.title),annotation.timestamp<start&&annotation.title>start&&(annotation.timestamp=start),annotation.title>end&&annotation.timestamp<end&&(annotation.title=end)),annotation.prop=JSON.stringify(contentTypeMap.get(annotation.type)),annotation.completed=completedItems.indexOf(annotation.id)>-1;try{advanced=JSON.parse(annotation.advanced)}catch(e){advanced=null}return annotation.rerunnable=advanced&&"1"===advanced.replaybehavior,annotation}))}(annotations,contentTypes,progress,start,end,completiondetails),annotations.sort(((a,b)=>a.timestamp-b.timestamp)),releventAnnotations=function(annotations){const skipsegments=annotations.filter((annotation=>"skipsegment"==annotation.type));let releventAnnotations=[];return annotations.forEach((annotation=>{let shouldAdd=!0;skipsegments.forEach((skipsegment=>{Number(annotation.timestamp)>Number(skipsegment.timestamp)&&Number(annotation.timestamp)<Number(skipsegment.title)&&(shouldAdd=!1)})),shouldAdd&&(releventAnnotations.push(annotation),isPreviewMode&&(annotation.completed=!0,annotation.previewMode=!0))})),releventAnnotations}(annotations),window.ANNOS=releventAnnotations,releventAnnotations.length>0&&!releventAnnotations.find((x=>"chapter"==x.type))&&function(releventAnnotations,start,contentTypes){releventAnnotations.unshift({id:0,title:M.util.get_string("startchapter","mod_interactivevideo"),formattedtitle:M.util.get_string("startchapter","mod_interactivevideo"),timestamp:start,type:"chapter",prop:JSON.stringify(contentTypes.find((x=>"chapter"==x.name))),xp:0,completed:!0,hide:!0})}(releventAnnotations,start,contentTypes),await async function(contentTypes,releventAnnotations,player,interaction,course,userid,completionpercentage,gradeiteminstance,grademax,vtype,preventskip,totaltime,start,end,cmid,token,completionid){const chapterContentType=contentTypes.find((x=>"chapter"==x.name));if(0==(contentTypes=contentTypes.filter((x=>releventAnnotations.map((y=>y.type)).includes(x.name)))).length)return void $("#chaptertoggle, #chapter-container-left, #chapter-container-right").remove();$("#chaptertoggle, #chapter-container-left, #chapter-container-right").removeClass("d-none");contentTypes.find((x=>"chapter"==x.name))||contentTypes.push(chapterContentType);await Promise.all(contentTypes.map((contentType=>new Promise((resolve=>{require([contentType.amdmodule],(function(Type){ctRenderer[contentType.name]=new Type(player,releventAnnotations,interaction,course,userid,completionpercentage,gradeiteminstance,grademax,vtype,preventskip,totaltime,start,end,contentType,cmid,token,displayoptions,completionid,extendedcompletion,{isPreviewMode:isPreviewMode,isCompleted:isCompleted});try{ctRenderer[contentType.name].init()}catch(error){}resolve()}))})))))}(contentTypes,releventAnnotations,player,interaction,course,userid,completionpercentage,gradeiteminstance,grademax,vtype,preventskip,totaltime,start,end,cmid,token,completionid),await renderAnnotationItems(releventAnnotations,0,end-start),$("#play").removeClass("d-none"),$("#spinner").remove(),$("#video-info").toggleClass("d-none d-flex"),new Promise((resolve=>{resolve()}))}))},runInteraction=async function(annotation){let force=arguments.length>1&&void 0!==arguments[1]&&arguments[1];player.pause();let isPaused=await player.isPaused();if(isPaused){if(lastrun=annotation.id,viewedAnno=[],releventAnnotations.forEach((x=>{Number(x.timestamp)<=Number(annotation.timestamp)&&viewedAnno.push(Number(x.id))})),viewedAnno.push(Number(annotation.id)),viewedAnno=[...new Set(viewedAnno)],$("#annotation-modal").modal("hide"),$("#message").not("[data-placement=bottom]").not(".sticky").not("[data-id=".concat(annotation.id,"]")).remove(),$("#end-screen, #start-screen").fadeOut(300),preventskip){const theAnnotations=releventAnnotations.filter((x=>Number(x.timestamp)<Number(annotation.timestamp)&&0==x.completed&&1==x.hascompletion));if(theAnnotations.length>0){const theAnnotation=theAnnotations[0];return await player.pause(),await player.seek(theAnnotation.timestamp),runInteraction(theAnnotation),void Toast.add(M.util.get_string("youmustcompletethistaskfirst","mod_interactivevideo"),{type:"danger"})}}"side"==annotation.displayoptions&&$(".sidebar-nav-item[data-id=".concat(annotation.id,"]")).length>0&&!force?($("body").hasClass("hassidebar")||$("#annotation-toggle").trigger("click"),$(".sidebar-nav-item[data-id=".concat(annotation.id,"]")).trigger("click")):(activityType=ctRenderer[annotation.type],setTimeout((()=>{activityType.runInteraction(annotation),$("#message.active").length>0&&$("#message.active").each((function(){const id=$(this).data("id");id!=annotation.id&&($(this).removeClass("active"),dispatchEvent("interactionclose",{annotation:{id:id}}))})),dispatchEvent("interactionrun",{annotation:annotation})}),100))}else runInteraction(annotation)},shareMoment=async()=>{if(!moment)return;const urlParams=new URLSearchParams(window.location.search);urlParams.delete("t");const newurl=window.location.protocol+"//"+window.location.host+window.location.pathname+"?"+urlParams.toString();window.history.replaceState(null,null,newurl)},updateTime=async duration=>{duration=Number(duration);let toUpdatetime=!1;return end&&0!=end||(toUpdatetime=!0),(!start||start>=duration||start<0||start>=duration)&&(toUpdatetime=!0),start=start>duration?0:start,toUpdatetime&&await $.ajax({url:M.cfg.wwwroot+"/mod/interactivevideo/ajax.php",method:"POST",dataType:"text",data:{action:"update_videotime",sesskey:M.cfg.sesskey,id:interaction,cmid:cmid,courseid:course,start:start,end:end&&0!=end?end:duration,contextid:M.cfg.contextid}}),end=!end||0==end||end>duration?duration:end,{start:start,end:end}};let loaded=!1,lookbacktime=0;const onLoaded=async()=>{if(loaded)return;1==displayoptions.passwordprotected&&player.support.password&&($("#start-screen").removeClass("d-none"),$(".video-block").removeClass("no-pointer bg-transparent")),loaded=!0,window.IVPLAYER=player,lookbacktime=Math.max(.5,player.frequency),0==player.support.playbackrate?$("#changerate").remove():$("#changerate").removeClass("d-none"),0==player.support.quality?$("#changequality").remove():$("#changequality").removeClass("d-none");const duration=player.totaltime;({start:start,end:end}=await updateTime(duration)),totaltime=end-start,$("#duration").text(convertSecondsToHMS(totaltime));let ratio=16/9;displayoptions.usefixedratio&&0!=displayoptions.usefixedratio||(ratio=player.aspectratio),$("#video-wrapper").css("padding-bottom",1/ratio*100+"%");let gap="125px";$("body").hasClass("embed-mode")?1==displayoptions.hidemainvideocontrols?$("#wrapper").css({width:"calc(100dvh * "+ratio+")"}):$("#wrapper").css({width:"calc((100dvh - 55px) * "+ratio+")"}):(1==displayoptions.hidemainvideocontrols&&(gap="55px"),$("#wrapper").css({width:"calc((100dvh - "+gap+" - 2rem) * "+ratio+")"})),$("#wrapper").attr("data-ratio",ratio),$("#wrapper").attr("data-gap",gap),$("#start-screen #start").focus();let vwrapper=document.querySelector("#video-wrapper");return new ResizeObserver((()=>{vwrapper.clientWidth>1050?$("#controller #expand").removeClass("d-none"):$("#controller #expand").addClass("d-none")})).observe(vwrapper),$("body").hasClass("embed-mode")?void 0:(vwrapper.scrollIntoView({behavior:"smooth",block:"end",inline:"nearest"}),player.live?($("#currenttime").next().remove(),$("#currenttime").remove(),$("#duration").text(M.util.get_string("live","mod_interactivevideo")),$("#remainingtime").text(M.util.get_string("live","mod_interactivevideo")),$("#taskinfo").addClass("no-pointer-events"),end=Number.MAX_SAFE_INTEGER,void replaceProgressBars(100)):void 0)},onReady=async()=>{if((window.braveEthereum||window.braveSolana)&&!player.allowAutoplay)return player.destroy(),Toast.add(M.util.get_string("braveautoplay","mod_interactivevideo"),{type:"danger",autohide:!1}),void setTimeout((()=>{$("#toast-0").css("margin-top","70px"),$("#interactivevideo-container").addClass("no-pointer-events"),$("#autoplay-error").tooltip("hide"),$("#autoplay-error").remove()}),500);player.pause();if(!await player.isPaused())return player.live||await player.seek(start),void onReady();loaded||await onLoaded(),player.audio&&$("#annotation-canvas").addClass("bg-black"),$("#annotation-canvas").removeClass("w-0"),$(".video-block").css("background","transparent"),$("#annotation-canvas").removeClass("d-none"),await getAnnotations(),player.live||($("#seekhead").draggable({containment:"#video-nav",axis:"x",cursor:"col-resize",start:async function(event,ui){await player.isPaused()||player.pause(),$(this).addClass("active"),$("#taskinfo").addClass("no-pointer-events"),$("#message").not("[data-placement=bottom]").not(".sticky").remove(),$("#end-screen").fadeOut(300),$("#seek").append('<div id="position"><div id="timelabel"></div></div>');let $position=$("#position");const relX=ui.position.left;$position.css("left",relX+"px");const percentage=relX/$(this).width(),formattedTime=convertSecondsToHMS(percentage*totaltime);$position.find("#timelabel").text(formattedTime)},drag:async function(event,ui){let timestamp=ui.position.left/$("#video-nav").width()*totaltime+start,percentage=ui.position.left/$("#video-nav").width();await replaceProgressBars(100*percentage),$("#seek #position").css("left",ui.position.left+"px"),$("#seek #position #timelabel").text(convertSecondsToHMS(timestamp-start)),await player.seek(timestamp)},stop:async function(){lastrun=null,viewedAnno=[],setTimeout((function(){$("#taskinfo").removeClass("no-pointer-events")}),200),setTimeout((function(){$("#seekhead").removeClass("active"),$("#seek #position").remove()}),1e3),player.play()}}),dispatchEvent("timeupdate",{time:start}))};let lastSaved;const onPaused=async()=>{if(!playerReady)return;if($("#playpause").find("i").removeClass("bi-pause-fill").addClass("bi-play-fill"),$("#playpause").attr("data-original-title",M.util.get_string("play","mod_interactivevideo")),player.live)return;cancelAnimationFrame(playingInterval);let t=await player.getCurrentTime(),watchedpoint=Math.round(t);Math.abs(watchedpoint-lastSaved)<5&&watchedpoint!=Math.round(end)||watchedpoint<start+5||(lastSaved=watchedpoint,$.ajax({url:M.cfg.wwwroot+"/mod/interactivevideo/ajax.php",method:"POST",dataType:"text",data:{action:"update_watchedpoint",sesskey:M.cfg.sesskey,completionid:completionid,watchedpoint:watchedpoint,contextid:M.cfg.contextid}}))};let videoEnded=!1;const onEnded=async()=>{if(!playerReady)return;if(videoEnded||player.live)return;if(await player.isPlaying())return player.pause(),void onEnded();onPaused(),dispatchEvent("timeupdate",{time:end}),$("#restart").removeClass("d-none").fadeIn(300),$("#end-screen").removeClass("d-none").fadeIn(300),dispatchEvent("ended",{time:end}),replaceProgressBars(100),videoEnded=!0,viewedAnno=[],timeended||$.ajax({url:M.cfg.wwwroot+"/mod/interactivevideo/ajax.php",method:"POST",dataType:"text",data:{action:"update_timeended",sesskey:M.cfg.sesskey,completionid:completionid,contextid:M.cfg.contextid,courseid:course,interactivevideo:interaction,userid:userid,updatestate:extendedcompletion&&1==JSON.parse(extendedcompletion).watchtillend?1:0},success:function(data){try{data=JSON.parse(data)}catch{return void window.console.log(data)}data&&dispatchEvent("completionupdated",{response:{overallcomplete:data.overallcomplete}})}})},onSeek=async t=>{if(!playerReady)return;if(player.live)return;t=t?Number(t):await player.getCurrentTime(),firstPlay||(window.resumetime=t),t>start&&t<end&&$("#end-screen, #start-screen").addClass("d-none");replaceProgressBars((t-start)/totaltime*100),dispatchEvent("timeupdate",{time:t}),viewedAnno=[],releventAnnotations.forEach((x=>{Number(x.timestamp)<t&&viewedAnno.push(Number(x.id))})),lastrun&&releventAnnotations.find((x=>x.id==lastrun)).timestamp>t&&(lastrun=null)};let visualized=!1,playingInterval=null,firstPlay=!1;const onPlaying=async()=>{if(!playerReady)return;if(player.audio&&!visualized&&(player.visualizer(),visualized=!0),$("body").hasClass("mobiletheme")&&!$("#wrapper").hasClass("fullscreen")&&$("#fullscreen").trigger("click"),$("#playpause").find("i").removeClass("bi-play-fill").addClass("bi-pause-fill"),$("#playpause").attr("data-original-title",M.util.get_string("pause","mod_interactivevideo")),player.live)return;$("#message.active").length>0&&$("#message.active").each((function(){const mid=$(this).data("id");mid&&($(this).removeClass("active"),dispatchEvent("interactionclose",{annotation:{id:mid}}))})),$("#annotation-modal").modal("hide"),$("#message").not("[data-placement=bottom]").not(".sticky").remove(),videoEnded?viewedAnno=[]:($("#end-screen, #start-screen").fadeOut(300),$("#restart").addClass("d-none")),firstPlay||($("#autoplay-error").tooltip("hide"),$("#autoplay-error").remove(),replaceProgressBars(window.resumetime?(window.resumetime-start)/totaltime*100:0),viewedAnno=[],firstPlay=!0,window.resumetime&&window.resumetime>start&&window.resumetime<end&&(player.allowAutoplay?await player.seek(window.resumetime):(await player.pause(),await player.seek(window.resumetime),player.play())),player.unMute());const intervalFunction=async function(){const isPlaying=await player.isPlaying(),isEnded=await player.isEnded(),isPaused=await player.isPaused();if(isEnded)return void onEnded(end);if(isPaused)return void onPaused();if(!isPlaying)return void("spotify"!=player.type&&"rutube"!=player.type&&"yt"!=player.type||(player.pause(),cancelAnimationFrame(playingInterval)));let t=await player.getCurrentTime();if(t=Number(t),t>end)return void onEnded(end);videoEnded=!1,dispatchEvent("timeupdate",{time:t});const time=Number(t.toFixed(2));let percentagePlayed=(t-start)/totaltime;percentagePlayed=percentagePlayed>1?1:percentagePlayed,replaceProgressBars(100*percentagePlayed);const theAnnotation=releventAnnotations.find((x=>((t-lookbacktime).toFixed(2)<=x.timestamp&&(t+player.frequency).toFixed(2)>=x.timestamp||time==x.timestamp)&&0!=x.id&&!viewedAnno.includes(Number(x.id))));if(theAnnotation){if(viewedAnno=[],releventAnnotations.forEach((x=>{Number(x.timestamp)<t&&viewedAnno.push(Number(x.id))})),$('#interactions-nav .annotation[data-id="'+theAnnotation.id+'"] .item').trigger("mouseover").addClass("active"),setTimeout((function(){$('#interactions-nav .annotation[data-id="'+theAnnotation.id+'"] .item').trigger("mouseout").removeClass("active")}),2e3),lastrun&&theAnnotation.id==lastrun)return;if(isPreviewMode)return;!theAnnotation.completed||theAnnotation.rerunnable?(replaceProgressBars((theAnnotation.timestamp-start)/totaltime*100),time<theAnnotation.timestamp-player.frequency&&await player.seek(theAnnotation.timestamp),runInteraction(theAnnotation)):theAnnotation.completed&&(time<theAnnotation.timestamp-player.frequency&&await player.seek(theAnnotation.timestamp),viewedAnno.push(Number(theAnnotation.id)))}};if(player.useAnimationFrame){const animate=async()=>{await player.isPlaying()&&(intervalFunction(),playingInterval=requestAnimationFrame(animate))};playingInterval=requestAnimationFrame(animate)}else{await player.isPlaying()&&intervalFunction()}};require(["mod_interactivevideo/player/"+vtype],(function(VideoPlayer){player=new VideoPlayer,1==displayoptions.passwordprotected&&player.support.password&&($("#start-screen").addClass("d-none"),$(".video-block").addClass("no-pointer bg-transparent"),$("#annotation-canvas").removeClass("d-none")),player.load(url,start,end,{showControls:1==displayoptions.useoriginalvideocontrols,customStart:!0,preload:!1,autoplay:1==displayoptions.autoplay,passwordprotected:1==displayoptions.passwordprotected&&player.support.password})}));let $toast=$(".toast-wrapper").detach();$("#wrapper").append($toast),$(document).on("click",".completion-required",(function(e){e.preventDefault(),e.stopImmediatePropagation(),Toast.add(M.util.get_string("youmustcompletethistaskfirst","mod_interactivevideo"),{type:"danger"})}));const handleUnskippable=async t=>{if(t||(t=await player.getCurrentTime()),releventAnnotations){const theAnnotation=releventAnnotations.find((x=>Number(x.timestamp)<Number(t.toFixed(2))&&0==x.completed&&0==JSON.parse(x.advanced).advskippable&&1==x.hascompletion));if(theAnnotation)return await player.pause(),await player.seek(theAnnotation.timestamp),runInteraction(theAnnotation),Toast.add(M.util.get_string("youmustcompletethistaskfirst","mod_interactivevideo"),{type:"danger"}),replaceProgressBars((theAnnotation.timestamp-start)/totaltime*100),!0}return!1};$(document).on("timeupdate",(async function(e){if(!playerReady||isPreviewMode||player.live)return;const t=e.originalEvent.detail.time;if(preventskip&&releventAnnotations){const theAnnotations=releventAnnotations.filter((x=>Number(x.timestamp)<Number(t.toFixed(2))&&0==x.completed&&1==x.hascompletion));if(theAnnotations.length>0){const theAnnotation=theAnnotations[0];await player.pause(),await player.seek(theAnnotation.timestamp),runInteraction(theAnnotation),Toast.add(M.util.get_string("youmustcompletethistaskfirst","mod_interactivevideo"),{type:"danger"}),replaceProgressBars((theAnnotation.timestamp-start)/totaltime*100)}}handleUnskippable(t)})),$(document).on("click","#message #refresh",(function(e){e.preventDefault(),e.stopImmediatePropagation();const id=$(this).data("id"),annotation=releventAnnotations.find((x=>x.id==id));$(this).closest("#message").remove(),dispatchEvent("interactionrefresh",{annotation:annotation}),runInteraction(annotation,!0)})),$(document).on("click","#fullscreen",(function(e){if(e.preventDefault(),!playerReady)return;let elem=document.getElementById("wrapper");$("#fullscreen").toggleClass("active"),$("#wrapper").hasClass("fullscreen")?document.exitFullscreen?document.exitFullscreen():document.mozCancelFullScreen?document.mozCancelFullScreen():document.webkitExitFullscreen?document.webkitExitFullscreen():document.msExitFullscreen&&document.msExitFullscreen():elem.requestFullscreen?elem.requestFullscreen():elem.mozRequestFullScreen?elem.mozRequestFullScreen():elem.webkitRequestFullscreen?elem.webkitRequestFullscreen():elem.msRequestFullscreen?elem.msRequestFullscreen():elem.webkitEnterFullscreen?elem.webkitEnterFullscreen():(Toast.add(M.util.get_string("fullscreenisnotsupported","mod_interactivevideo"),{type:"danger"}),$("#fullscreen").remove())})),$(document).on("fullscreenchange",(async function(){if(document.fullscreenElement)$("#wrapper, #interactivevideo-container").addClass("fullscreen"),$("#video-wrapper").css("padding-bottom","0"),$("#wrapper [data".concat(bsAffix,'-toggle="tooltip"]')).tooltip({container:"#wrapper",boundary:"window"}),$("#controller").addClass("bg-black").removeClass("bg-dark");else{$("#wrapper, #interactivevideo-container").removeClass("fullscreen");let ratio=16/9;displayoptions.usefixedratio&&0!=displayoptions.usefixedratio||(ratio=player.aspectratio),$("#video-wrapper").css("padding-bottom",1/ratio*100+"%"),$("#controller").addClass("bg-dark").removeClass("bg-black")}$("#wrapper #fullscreen i").toggleClass("bi-fullscreen bi-fullscreen-exit")}));let idleInterval=null;$(document).on("visibilitychange",(async function(){if(displayoptions.pauseonblur&&1==displayoptions.pauseonblur){if(!playerReady)return;"hidden"==document.visibilityState&&player.pause()}"hidden"==document.visibilityState?idleInterval=setInterval((async()=>{if(await player.isPaused()||videoEnded||!playerReady||!player||!firstPlay){try{player.destroy()}catch(error){}cancelAnimationFrame(playingInterval),clearInterval(idleInterval),$(document).off(),videoEnded||($("#start-screen").show().removeClass("d-none").addClass("idled"),$("#start-screen #play").removeClass("d-none")),$(document).on("click","#start-screen #play, #endscreen #restart",(function(e){e.preventDefault(),location.reload()})),$("#controller").addClass("no-pointer-events"),Toast.add(M.util.get_string("idlealert","mod_interactivevideo"),{type:"danger",autohide:!1,closeButton:!0})}}),6e4*(videoEnded?5:30)):clearInterval(idleInterval)})),$(document).on("click","#controller #expand",(function(e){e.preventDefault(),$("body").toggleClass("limited-width"),localStorage.setItem("limitedwidth",$("body").hasClass("limited-width")),$(this).find("i").toggleClass("bi-square bi-file")})),$(document).on("click","#controller #share",(async function(e){e.preventDefault(),e.stopImmediatePropagation();let time=await player.getCurrentTime();const url=window.location.href;let shareurl=url+(url.indexOf("?")>0?"&":"?")+"t="+Math.round(time);shareurl=shareurl.replace(/&embed=1/g,""),await navigator.clipboard.writeText(shareurl);const copied=M.util.get_string("copiedtoclipboard","mod_interactivevideo");Toast.add(copied,{type:"success",autohide:!0,delay:2e3})})),$(document).on("mouseenter","#video-nav #seek",(function(e){if(!playerReady)return;$(this).append('<div id="position"><div id="timelabel"></div></div>');let $position=$("#position");const parentOffset=$(this).offset(),relX=e.pageX-parentOffset.left;$position.css("left",relX+"px");const percentage=relX/$(this).width(),formattedTime=convertSecondsToHMS(percentage*totaltime);$position.find("#timelabel").text(formattedTime)})),$(document).on("mousemove","#video-nav #seek",(function(e){if(!playerReady)return;const parentOffset=$(this).offset(),relX=e.pageX-parentOffset.left,percentage=relX/$(this).width(),formattedTime=convertSecondsToHMS(percentage*totaltime);$("#position").css("left",relX+"px"),$("#position #timelabel").text(formattedTime)})),$(document).on("mouseleave","#video-nav #seek",(function(){$("#position").remove()})),$(document).on("click","#interactions-nav .annotation, #video-nav .annotation",(async function(e){e.preventDefault(),e.stopImmediatePropagation();const timestamp=$(this).data("timestamp");if(await handleUnskippable(timestamp))return;if($loader.fadeIn(300),$(this).hasClass("no-click"))return void Toast.add(M.util.get_string("youcannotviewthisannotationyet","mod_interactivevideo"),{type:"danger"});if(await player.getCurrentTime()==timestamp&&lastrun)return void $loader.fadeOut(300);lastrun=null;await player.isPaused()||player.pause(),await replaceProgressBars((timestamp-start)/totaltime*100),await player.seek(Number(timestamp));const id=$(this).data("id"),theAnnotation=releventAnnotations.find((x=>x.id==id));runInteraction(theAnnotation),$loader.fadeOut(300);const preceedingAnno=releventAnnotations.filter((x=>x.timestamp<timestamp)).map((x=>Number(x.id)));viewedAnno=preceedingAnno,viewedAnno.push(id),viewedAnno=[...new Set(viewedAnno)]})),$(document).on("click","#seek",(async function(e){if(!playerReady)return;if(e.preventDefault(),e.stopImmediatePropagation(),$("#video-nav").hasClass("no-click"))return void Toast.add(M.util.get_string("seekingdisabled","mod_interactivevideo"),{type:"danger"});$("#start-screen").fadeOut(300),$("#end-screen").fadeOut(300);const parentOffset=$(this).offset(),percentage=(e.pageX-parentOffset.left)/$(this).width();await replaceProgressBars(100*percentage),$loader.fadeIn(300),await player.seek(percentage*totaltime+start);await player.isPlaying()&&!videoEnded||await player.play(),viewedAnno=[],setTimeout((()=>{$("#position").remove(),$loader.fadeOut(300)}),300)})),$(document).on("click","#start-screen #play",(async function(e){e.preventDefault(),$(this).hasClass("reload")?location.reload():($("#start-screen").fadeOut(300),$(this).addClass("d-none"),$videoNav.removeClass("d-none"),player.play())})),$(document).on("click","#end-screen #restart",(async function(e){e.preventDefault(),dispatchEvent("iv:playerRestart"),$("#message").remove(),$("body").hasClass("hassidebar")&&($("#annotation-toggle").trigger("click"),$("#annotation-sidebar, #annotation-toggle").remove(),$("body").removeClass("hassidebar"),$(".iv-sidebar").addClass("hide")),viewedAnno=[],lastrun=null,$loader.fadeIn(300),await player.seek(start),replaceProgressBars(0),$("#end-screen").fadeOut(300),$(this).addClass("d-none"),$videoNav.removeClass("d-none"),player.play(),$loader.fadeOut(300)})),$(document).on("click","#video-wrapper .video-block",(async function(e){if(!playerReady)return;if(e.preventDefault(),player.live&&(firstPlay=!0),!firstPlay)return void player.play();await player.isPlaying()?await player.pause():player.play()})),$(document).on("click","#playpause",(async function(e){if(!playerReady)return;e.preventDefault(),$(this).tooltip("hide");if(await player.isPlaying())await player.pause();else{await player.getCurrentTime()>=end?$("#end-screen #restart").trigger("click"):player.play()}})),$(document).on("click","li.anno",(async function(e){e.preventDefault();const id=$(this).data("id");$("li.annotation[data-id=".concat(id,"]")).trigger("click"),$(this).closest("#chapter-container-left").length>0&&$("#chaptertoggle .btn").trigger("click")})),$(document).on("click","#toolbar #annotation-toggle",(function(e){e.preventDefault(),$("body").addClass("hassidebar"),$("#annotation-sidebar").removeClass("hide");const current=$("#sidebar-nav .sidebar-nav-item.active").data("id");current&&dispatchEvent("interactionrun",{annotation:releventAnnotations.find((x=>x.id==current))})})),$(document).on("click","#mute",(function(e){e.preventDefault(),$(this).tooltip("hide"),$(this).toggleClass("active"),$(this).hasClass("active")?(player.mute(),$(this).attr("data-original-title",M.util.get_string("unmute","mod_interactivevideo"))):(player.unMute(),$(this).attr("data-original-title",M.util.get_string("mute","mod_interactivevideo"))),$(this).find("i").toggleClass("bi-volume-mute bi-volume-up"),$(this).tooltip("show")})),$(document).on("click",".changerate",(function(e){e.preventDefault();const rate=$(this).data("rate");player.setRate(rate),$(".changerate").find("i").removeClass("bi-check"),$(this).find("i").addClass("bi-check")})),$("#changequality").on("shown.bs.dropdown",(async function(){let quality=await player.getQualities();$("#qualitieslist").empty();let currentQuality=quality.currentQuality;null===currentQuality&&(currentQuality=$(this).data("current"));let qualities=quality.qualities,qualitiesLabel=quality.qualitiesLabel;qualities.forEach(((q,i)=>{$("#qualitieslist").append('<a class="dropdown-item changequality text-white px-3" data-quality="'.concat(q,'"\n                         href="#"><i class="bi ').concat(q==currentQuality?"bi-check":"",' fa-fw"></i>').concat(qualitiesLabel[i],"</a>"))})),$(this).find("[data".concat(bsAffix,"-toggle=dropdown]")).dropdown("update")})),$(document).on("click",".changequality",(function(e){e.preventDefault();const quality=$(this).data("quality");player.setQuality(quality),$(".changequality").find("i").removeClass("bi-check"),$(this).find("i").addClass("bi-check")})),$(document).on("click","#changecaption .changecaption",(function(e){e.preventDefault();const lang=$(this).data("lang");player.setCaption(lang),$("#changecaption .changecaption").find("i").removeClass("bi-check"),$(this).find("i").addClass("bi-check"),""==lang?$("#changecaption .btn i").removeClass("bi-badge-cc-fill").addClass("bi-badge-cc"):$("#changecaption .btn i").removeClass("bi-badge-cc").addClass("bi-badge-cc-fill"),localStorage.setItem("caption-".concat(userid),lang)})),$(document).on("iv:playerReady",(function(){onReady()})),$(document).on("iv:playerPaused",(function(){$(".tooltip").remove(),dispatchEvent("videoPaused"),onPaused()})),$(document).on("iv:playerPlaying",(function(){onPlaying(),$loader.fadeOut(300)})),$(document).on("iv:playerEnded",(function(){onEnded()})),$(document).on("iv:playerSeek",(function(e){player.live||onSeek(e.detail.time)})),$(document).on("iv:playerLoaded",(function(e){onLoaded(e.detail);const captions=e.detail.tracks;if(!captions||0==captions.length)return;$("#changecaption").removeClass("d-none"),$("#changecaption .dropdown-menu").html('<a class="dropdown-item changecaption px-3"\n                     data-lang="" href="#">\n                     <i class="bi fa-fw bi-check"></i>'.concat(M.util.get_string("off","mod_interactivevideo"),"</a>")),captions.forEach((caption=>{$("#changecaption .dropdown-menu").append('<a class="dropdown-item changecaption text-white px-3"\n                         data-lang="'.concat(caption.code,'" href="#"><i class="bi fa-fw"></i>').concat(caption.label,"</a>"))}));const lang=localStorage.getItem("caption-".concat(userid));lang&&lang.length&&$('#changecaption .changecaption[data-lang="'+lang+'"]').trigger("click")})),$(document).on("iv:playerError",(function(){Toast.add(M.util.get_string("thereisanissueloadingvideo","mod_interactivevideo"),{type:"danger"}),$("#annotation-canvas").removeClass("d-none"),$("#start-screen").addClass("d-none"),$(".video-block").addClass("no-pointer bg-transparent"),$("#spinner").remove()})),$(document).on("iv:playerRateChange",(function(e){$(".changerate").find("i").removeClass("bi-check"),$('.changerate[data-rate="'.concat(e.originalEvent.detail.rate,'"]')).find("i").addClass("bi-check")})),$(document).on("iv:playerQualityChange",(function(e){$("#changequality").attr("data-current",e.originalEvent.detail.quality),$(".changequality").find("i").removeClass("bi-check"),$('.changequality[data-quality="'.concat(e.originalEvent.detail.quality,'"]')).find("i").addClass("bi-check")})),$(document).on("annotationitemsrendered",(function(){try{$("#wrapper [data".concat(bsAffix,'-toggle="tooltip"]')).tooltip({container:"#wrapper",boundary:"window"})}catch(error){}if(1==displayoptions.disableinteractionclickuntilcompleted&&$interactionNav.find("li:not(.completed)").addClass("no-click"),1==displayoptions.disableinteractionclick&&$interactionNav.find("li").addClass("no-click"),1==displayoptions.preventseeking&&($interactionNav.find("li").addClass("no-click"),$videoNav.addClass("no-click")),$interactionNav.find("li").length>0&&$("#taskinfo").removeClass("border-0"),playerReady||(playerReady=!0),!isPreviewMode&&!firstPlay){let autoplay=1==displayoptions.autoplay,time=start;$(".intro-content").hasClass("hasintro")&&(autoplay=!1),(uprogress.lastviewed>start&&uprogress.lastviewed<end-5||moment)&&(autoplay=!0,time=moment?Number(moment):uprogress.lastviewed,time=time>=end||time<start?start:time),window.resumetime=time,replaceProgressBars((time-start)/totaltime*100),player.live&&replaceProgressBars(100),autoplay&&player.allowAutoplay&&setTimeout((async()=>{player.unMute(),moment||$("#play").trigger("click")}),1e3),shareMoment()}})),$("[data".concat(bsAffix,'-toggle="tooltip"]')).on("click",(function(){const $this=$(this);setTimeout((function(){$this.tooltip("hide")}),2e3)})),window.addEventListener("beforeunload",(function(){player.pause(),onPaused(),$(document).off(),cancelAnimationFrame(playingInterval)})),$(document).on("interactionrun",(function(e){const annotation=e.originalEvent.detail.annotation;let windowAnnos=window.ANNOS,windowAnno=windowAnnos.find((x=>x.id==annotation.id));windowAnno&&(windowAnno.starttime=windowAnno.starttime?windowAnno.starttime:(new Date).getTime(),windowAnno.newstarttime=(new Date).getTime(),windowAnno.completedtime=windowAnno.completedtime?windowAnno.completedtime:null,windowAnno.duration=windowAnno.duration>0?windowAnno.duration:0),windowAnnos=windowAnnos.filter((x=>x.id!=annotation.id)),windowAnnos.push(windowAnno),window.ANNOS=windowAnnos})),$(document).on("interactionclose interactionrefresh",(function(e){const annotation=e.originalEvent.detail.annotation;let windowAnnos=window.ANNOS,windowAnno=windowAnnos.find((x=>x.id==annotation.id));windowAnno&&(windowAnno.duration=windowAnno.duration+((new Date).getTime()-windowAnno.newstarttime)),windowAnnos=windowAnnos.filter((x=>x.id!=annotation.id)),windowAnnos.push(windowAnno),window.ANNOS=windowAnnos})),$(document).on("completionupdated",(function(e){const annotation=e.originalEvent.detail.target;if(!annotation)return;let windowAnnos=window.ANNOS,windowAnno=windowAnnos.find((x=>x.id==annotation.id));windowAnno&&("mark-done"==e.originalEvent.detail.action?windowAnno.completedtime=(new Date).getTime():windowAnno.completedtime=null),windowAnnos=windowAnnos.filter((x=>x.id!=annotation.id)),windowAnnos.push(windowAnno),window.ANNOS=windowAnnos,$("#message[data-id="+annotation.id+"]").addClass("active");let anno=releventAnnotations.find((x=>x.id==annotation.id)),advanced=anno.advanced;advanced=advanced?JSON.parse(advanced):{},0==advanced.advdismissible&&anno.completed?$("#controller, #video-wrapper, .sidebar-nav-item").removeClass("completion-required"):0!=advanced.advdismissible||anno.completed||($("#controller").addClass("completion-required"),"bottom"!=$("#message.active").data("placement")&&"side"!=$("#message.active").data("placement")||$("#video-wrapper").addClass("completion-required"),"side"==$("#message.active").data("placement")&&$(".sidebar-nav-item").addClass("completion-required")),anno.completed?$(".sidebar-nav-item[data-id="+annotation.id+"]").addClass("completed"):$(".sidebar-nav-item[data-id="+annotation.id+"]").removeClass("completed")})),$(document).on("iv:autoplayBlocked",(function(e){e.preventDefault(),!1===e.originalEvent.detail.requireVideoBlock&&$(".video-block").remove(),$("body").append('<button id="autoplay-error" data'.concat(bsAffix,'-toggle="tooltip"\n                     title="').concat(M.util.get_string("autoplayblocked","mod_interactivevideo"),'"\n                    class="btn btn-danger p-2 iv-rounded-circle pulse"><i class="bi bi-x-lg"></i></button>')),$("#autoplay-error").tooltip("show"),$(document).on("click","#autoplay-error",(function(){$("#autoplay-error").tooltip("hide"),$(this).fadeOut(300,"swing",(function(){$(this).remove()}))}))})),$(document).on("click","#message[data-placement]:not(.active)",(function(e){e.preventDefault(),$(this).addClass("active"),dispatchEvent("interactionrun",{annotation:releventAnnotations.find((x=>x.id==$(this).data("id")))})}))}}}));

//# sourceMappingURL=viewannotation.min.js.map